ALTER TABLE NAF47.SSO_FDIN_DET_SOL
 DROP PRIMARY KEY CASCADE;

DROP TABLE NAF47.SSO_FDIN_DET_SOL CASCADE CONSTRAINTS;

CREATE TABLE NAF47.SSO_FDIN_DET_SOL
(
  ID_SOLUCION     VARCHAR2(20 BYTE),
  CODEMPRESA      NUMBER,
  CODCLIENTE      NUMBER,
  INSTALACION     NUMBER,
  TIPOSERVICIO    VARCHAR2(5 BYTE),
  NOTRANSACCION   NUMBER,
  TIPOFACTURA     VARCHAR2(200 BYTE),
  NOMBRESUCURSAL  VARCHAR2(400 BYTE),
  DIRECCIN       VARCHAR2(4000 BYTE),
  PAIS            VARCHAR2(400 BYTE),
  DEPARTAMENTO    VARCHAR2(400 BYTE),
  MUNICIPIO       VARCHAR2(400 BYTE),
  IDBUNDLE        VARCHAR2(200 BYTE),
  DETALLEFACTURA  VARCHAR2(100 BYTE),
  PAGOUNICO       VARCHAR2(1 BYTE),
  PLAZO           NUMBER
)
TABLESPACE NAF47
RESULT_CACHE (MODE DEFAULT)
PCTUSED    0
PCTFREE    10
INITRANS   1
MAXTRANS   255
STORAGE    (
            MAXSIZE          UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
LOGGING 
NOCOMPRESS 
NOCACHE
NOPARALLEL
MONITORING;


CREATE UNIQUE INDEX NAF47.PK_SSO_SDIN_DET_SOL ON NAF47.SSO_FDIN_DET_SOL
(ID_SOLUCION, CODEMPRESA, CODCLIENTE, INSTALACION, TIPOSERVICIO, 
NOTRANSACCION)
LOGGING
TABLESPACE NAF47
PCTFREE    10
INITRANS   2
MAXTRANS   255
STORAGE    (
            MAXSIZE          UNLIMITED
            PCTINCREASE      0
            BUFFER_POOL      DEFAULT
            FLASH_CACHE      DEFAULT
            CELL_FLASH_CACHE DEFAULT
           )
NOPARALLEL;


ALTER TABLE NAF47.SSO_FDIN_DET_SOL ADD (
  CONSTRAINT PK_SSO_SDIN_DET_SOL
  PRIMARY KEY
  (ID_SOLUCION, CODEMPRESA, CODCLIENTE, INSTALACION, TIPOSERVICIO, NOTRANSACCION)
  USING INDEX NAF47.PK_SSO_SDIN_DET_SOL
  ENABLE VALIDATE);

ALTER TABLE NAF47.SSO_FDIN_DET_SOL ADD (
  CONSTRAINT FK1_SSO_SDIN_DET_SOL 
  FOREIGN KEY (ID_SOLUCION, CODEMPRESA, CODCLIENTE, INSTALACION, TIPOSERVICIO, NOTRANSACCION) 
  REFERENCES NAF47.SSO_ADENDA (IDSOLUCION,CODEMPRESA,CODCLIENTE,INSTALACION,TIPOSERVICIO,NOTRANSACCION)
  ENABLE VALIDATE,
  CONSTRAINT FK2_SSO_FDIN 
  FOREIGN KEY (CODEMPRESA, CODCLIENTE, INSTALACION, TIPOSERVICIO, NOTRANSACCION) 
  REFERENCES NAF47.SSO_FDIN (CODEMPRESA,CODCLIENTE,INSTALACION,TIPOSERVICIO,NOTRANSACCION)
  ENABLE VALIDATE);
